#include "harness.h"
//Test case that shows that we need to keep the upper bound of an NT pointer
// correctly aligned.

int garbage1 = 0xaaaaaaaa;
//An array of safe pointers.
int (NT array)[2] = {-1, 0};
int garbage2 = 0x55555555;

TESTDEF baseline: success

int main() {

  { TRUSTEDBLOCK
    //Make sure the first byte of array[2] and the last byte of array[0] 
    // are nonzero, or this test won't work.
      if ( *((char*)(&array[2])) == 0) {
        printf("Problem with the test case: *((char*)(&array[2])) == 0\n");
        exit(-1);
      }
      if ( *(((char*)array)+3) == 0) {
        printf("Problem with the test case: *(((char*)array)+3) == 0\n");
        exit(-1);
      }
  }

  unsigned long b = ((unsigned long)array);
  unsigned long e = ((unsigned long)array) + 3;
  unsigned long e_bad = ((unsigned long)array) + 11;
  int * NT BND(b,e) p = array;

  //Because e is unaligned, the NT extension of the bounds to e_bad will
  //succeed.
  int * NT BND(b,e_bad) illegal = p+2; //KEEP badNT: error = some error message

  //Now we can illegally read/write p[2] a.k.a. garbage2
  int tmp = *illegal;                  //KEEP badNT
  printf("p[2] == 0x%x\n", tmp);       //KEEP badNT
  *illegal = 5;                        //KEEP badNT

  return 0;
}
